<? $ph_ForceDec = true;
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * Copyright (c) 1999 Holotech Enterprises (phorm@holotech.net)
 *
 * You may freely distribute this program as-is, without modifications,
 * and with the accompanying example files and documentation. You may use
 * this program freely, and modify it for your own purposes. There is no
 * charge for this program, but if you register it, you will:
 *
 *   1) Encourage me to continue developing it
 *   2) Automatically receive future releases
 *   3) Have free technical support for Phorm
 *   4) Earn my eternal gratitude
 *
 * To register, include at least your name and email address, and send
 * US$10 to:
 *
 *      Alan Little
 *      Holotech Enterprises
 *      2753 Manchester Rd.
 *      Ann Arbor, Michigan  48104  USA
 *
 * Please make checks and money orders payable to Alan Little.
 *
 * I hope you find this program useful. Aloha.
 *                                                 Alan Little
 *                                                 April 2000
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*
Phorm Variables:

Phorm's configuration variables ($PHORM_) are summarized in Appendix
B of the documentation. Internal variables ($ph_) are summarized here.

Abort    = Signals the rest of the program to stop processing
Admin    = Error message(s) to be emailed to the system administrator
af       = File handle of the acknowledgement template
aidx     = Index for traversing the argument array for the ONEOF criterion
Alerts   = Internal alert message(s)
aline    = A line from the ack template file
Args[]   = Any arguments for the current criterion
bh       = File handle of phormbase.txt
bline    = A line from phormbase.txt
Cards[]  = Associative array for converting credit card names to codes
chdir    = A directory from phormbase.txt to change to
Comments = Any comments on the current criterion line
Crit     = The current validation criterion
CType    = The value of the card type field (Visa, Amex, etc.)
CVal     = Indicates whether the credit card number is valid
ef       = File handle for the validation error message file
eline    = A line from the validation error message file
ErrFile  = Holds the contents of the validation error file for processing.
errfile  = Index into $ph_errfiles[] for which file to use
ErrLevel = The highest validation error level that's occurred
Errs     = Fatal error messages that are displayed to the visitor
fidx     = File index for loading validation error message files
FILES    = Indicates we're currently loading validation error message files
Files[]  = Array of validation error message file names
ForceDec = If true, the user must explicitly declare variables from the form
form     = A form name from phormbase.txt to compare with $PHORM_BASE
Home     = The user's Phorm directory
HTLink   = The link to holotech.net
HTTag    = The Phorm/Holotech tag for the end of email messages
ID       = The connection ID for MySQL logging
idx      = General-purpose index variable
key      = A throwaway to hold the key while traversing an array with each()
lf       = File handle of the log file
LogLine  = Holds the values of the variables to be logged
LogVars  = The list of variables to log, from $PHORM_LOGVAR
MaxFile  = The size of $ph_Files[]
mh       = File handle for phormconfigm.inc
mlin     = A line of the validation failure message
Msg      = The failure message for the current criterion
MsgLevel = The error level of the current criterion
nul      = Holds unimportant values temporarily
path     = A path from phormbase.txt
QString  = The query to submit to MySQL for logging
regs     = When parsing for variable subs, holds the variable information
RegEx    = Optionally, the index of the regex to use for variable substitution
ReqHdr   = HTML header to output if a variable in $PHORM_REQ is missing
ReqVars  = The list of variables required in $PHORM_REQ
Result   = The result of the MySQL query
rf       = File handle of the responder template
rline    = A line from the responder template
RULES    = Indicates we're currently processing validation rules
selected = Indicates whether the MySQL database was successfully selected
tf       = File handle for the email template file
tkln     = Holds a line while it's being parsed for variable substitutions
tline    = A line from the email template file
tmax     = The maximum number of items in $PHORM_TMPL[]
uh       = File handle for phormusers.txt
uline    = A line from phormusers.txt
varHold  = An array to hold $PHORM_ variables passed from the form
VarLock  = An array to hold $PHORM_ variables defined in phormconfigm.inc
Val      = The value of the variable being validated
val      = Holds variable values while processing the ForceDec directive
ValCat   = Holds values to be concatenated
ValErr   = A flag indicating a validation error
ValMsg[] = Holds error messages for the various levels
Var      = The name of the variable being validated
var      = Holds variable names while processing the ForceDec directive
Vers     = The current version of Phorm
vf       = File handle for the VALDEFS file
vlin     = A line from the VALDEFS file
vRegs    = An array of possible regexes to use for variable substitution
vReg     = The actual regex to use
*/

/*
  Function to substitute for in_array in version < 4.0 */
  function inarray($needle, $haystack) {
    if (substr(phpversion(), 0, 1) > 3) return in_array($needle, $haystack);
    while (list(, $straw) = each($haystack))
      if ($straw == $needle) return true;
    return false;
  }

/*
  Function to validate a credit card number with the Luhn Mod 10 formula.
  Returns true if the number is valid, false otherwise. */
  function ph_luhn($CCNum) {
    $Total = 0;
    $CCNum = strrev($CCNum);

    for ($x=0; $x<strlen($CCNum); $x++) {
      $digit = substr($CCNum,$x,1);
      if ($x/2 != floor($x/2)) {
        $digit *= 2;
        if (strlen($digit) == 2)
          $digit = substr($digit,0,1) + substr($digit,1,1);
      }
      $Total += $digit;
    }
    if ($Total % 10 == 0) return true; else return false;
  }

  function MailChek($Addr, $Level, $Timeout = 15000) {

//  Valid Top-Level Domains
    $gTLDs = "com:net:org:edu:gov:mil:int:arpa:";
    $CCs   = "ad:ae:af:ag:ai:al:am:an:ao:aq:ar:as:at:au:aw:az:ba:bb:bd:be:bf:".
             "bg:bh:bi:bj:bm:bn:bo:br:bs:bt:bv:bw:by:bz:ca:cc:cf:cd:cg:ch:ci:".
             "ck:cl:cm:cn:co:cr:cs:cu:cv:cx:cy:cz:de:dj:dk:dm:do:dz:ec:ee:eg:".
             "eh:er:es:et:fi:fj:fk:fm:fo:fr:fx:ga:gb:gd:ge:gf:gh:gi:gl:gm:gn:".
             "gp:gq:gr:gs:gt:gu:gw:gy:hk:hm:hn:hr:ht:hu:id:ie:il:in:io:iq:ir:".
             "is:it:jm:jo:jp:ke:kg:kh:ki:km:kn:kp:kr:kw:ky:kz:la:lb:lc:li:lk:".
             "lr:ls:lt:lu:lv:ly:ma:mc:md:mg:mh:mk:ml:mm:mn:mo:mp:mq:mr:ms:mt:".
             "mu:mv:mw:mx:my:mz:na:nc:ne:nf:ng:ni:nl:no:np:nr:nt:nu:nz:om:pa:".
             "pe:pf:pg:ph:pk:pl:pm:pn:pr:pt:pw:py:qa:re:ro:ru:rw:sa:sb:sc:sd:".
             "se:sg:sh:si:sj:sk:sl:sm:sn:so:sr:st:su:sv:sy:sz:tc:td:tf:tg:th:".
             "tj:tk:tm:tn:to:tp:tr:tt:tv:tw:tz:ua:ug:uk:um:us:uy:uz:va:vc:ve:".
             "vg:vi:vn:vu:wf:ws:ye:yt:yu:za:zm:zr:zw:";

//  The countries can have their own 'TLDs', e.g. mydomain.com.au
    $cTLDs = "com:net:org:edu:gov:mil:co:ne:or:ed:go:mi:";

    $fail = 0;

//  Shift the address to lowercase to simplify checking
    $Addr = strtolower($Addr);

//  Split the Address into user and domain parts
    $UD = explode("@", $Addr);
    if (sizeof($UD) != 2 || !$UD[0]) $fail = 1;

//  Split the domain part into its Levels
    $Levels = explode(".", $UD[1]); $sLevels = sizeof($Levels);
    if ($sLevels < 2) $fail = 1;

//  Get the TLD, strip off trailing ] } ) > and check the length
    $tld = $Levels[$sLevels-1];
    $tld = ereg_replace("[>)}]$|]$", "", $tld);
    if (strlen($tld) < 2 || strlen($tld) > 3 && $tld != "arpa") $fail = 1;

    $Level--;

//  If the string after the last dot isn't in the generic TLDs or country codes, it's invalid.
    if ($Level && !$fail) {
    $Level--;
    if (!ereg($tld.":", $gTLDs) && !ereg($tld.":", $CCs)) $fail = 2;
    }

//  If it's a country code, check for a country TLD; add on the domain name.
    if ($Level && !$fail) {
    $cd = $sLevels - 2; $domain = $Levels[$cd].".".$tld;
    if (ereg($Levels[$cd].":", $cTLDs)) { $cd--; $domain = $Levels[$cd].".".$domain; }
    }

//  See if there's an MX record for the domain
    if ($Level && !$fail) {
    $Level--;
    if (!getmxrr($domain, $mxhosts, $weight)) $fail = 3;
    }

//  Attempt to connect to port 25 on an MX host
    if ($Level && !$fail) {
    $Level--;
    while (!$sh && list($nul, $mxhost) = each($mxhosts))
      $sh = fsockopen($mxhost, 25);
    if (!$sh) $fail=4;
    }

//  See if anyone answers
    if ($Level && !$fail) {
    $Level--;
    set_socket_blocking($sh, false);
    $out = ""; $t = 0;
    while ($Timeout-- && !$out)
      $out = fgets($sh, 256);
    if (!ereg("^220", $out)) $fail = 5;
    }

    if ($sh) fclose($sh);

    return $fail;
  } //MailChek

/*
  Function to parse attributes from an HTML tag */
  function ParseTag ($Tag) {
    $QPat = "^\"[^\"]*\"";
    $TagType = true;

    $Tag = ereg_replace("<|>", "", $Tag);

    while ($AttLen = ereg("^[/A-Za-z0-9_-]+", $Tag, $regs)) {
      $Tag = substr($Tag, $AttLen);
      $Tag = ereg_replace("^[[:space:]]*", "", $Tag);
      if ($TagType) {
        $Tag = ereg_replace("^[[:space:]]*", "", $Tag);
        $Atts["TAG"] = $regs[0];
        $TagType = false;
        continue;
      }
      if (ereg("^=", $Tag, $nul)) {
        $Tag = ereg_replace("^=[[:space:]]*", "", $Tag);
        if (ereg("^\"", $Tag, $nul)) {
          $nul = ereg($QPat, $Tag, $aregs);
          $Atts[$regs[0]] = ereg_replace("\"", "", $aregs[0]);
          $Chop = "^$aregs[0][[:space:]]*";
          $Tag = ereg_replace($Chop, "", $Tag);
        }
        else {
          $nul = ereg("^[^[:space:]]*", $Tag, $aregs);
          $Atts[$regs[0]] = $aregs[0];
          $Chop = "^$aregs[0][[:space:]]*";
          $Tag = ereg_replace($Chop, "", $Tag);
        }
      }
      else {
        $Atts[$regs[0]] = true;
        $Tag = ereg_replace("^[[:space:]]*", "", $Tag);
      }
    }
    return $Atts;
  }

/*
  Debugging Function */
  function gdump() {
    global $ph_varHold, $HTTP_GET_VARS, $HTTP_POST_VARS,
           $HTTP_COOKIE_VARS, $argv;
    reset($GLOBALS);
    while (list($key, $val) = each($GLOBALS)) {
      if (trim($val) == "Array") {
        echo "<B>$key:</B><BR>";
        while (list($var, $val) = each($$key)) {
          echo "&nbsp;&nbsp;$val<BR>";
        }
      }
      else {
        echo "$key: $val<BR>";
      }
    }
    exit;
  }

/* -----------------------------------------------------------------------
   ==============================  BEGIN  ================================
   ----------------------------------------------------------------------- */

/*
  Unset any ph_ variables to prevent anyone from trying to sneak something
  in (such as ph_debug variables!) */
  while (list($ph_var, $ph_val) = each($GLOBALS))
    if (ereg("^ph_", $ph_var) && !ereg("^ph_ForceDec$", $ph_var)) {
      unset($$ph_var);
      unset($ph_var);
    }
  reset($GLOBALS);

  $ph_Vers = "Phorm v2.51L";

  $ph_HTLink =
    "<BR><BR><CENTER><FONT SIZE=1>".
    "<A HREF=\"http://www.phorm.com/\">$ph_Vers</A>".
    "</FONT></CENTER>";

  $ph_HTTag =
    "\n\n\n\n--\n$ph_Vers by Holotech Enterprises http://www.holotech.net/";

  $ph_config_delim = "\t";
  
/*
  Just to be sure */
  $HTTP_REFERER = getenv("HTTP_REFERER");
  $REMOTE_ADDR  = getenv("REMOTE_ADDR");
  
  $ph_Cards["mastercard"]       = "mcd";
  $ph_Cards["visa"]             = "vis";
  $ph_Cards["american express"] = "amx";
  $ph_Cards["discover"]         = "dsc";
  $ph_Cards["diners club"]      = "dnc";

  if (!trim($ph_Home = exec("pwd"))) $ph_Home = exec("cd");

/*
  Process phormbase.php3 */
  if ($PHORM_BASE) {
    $ph_phormbase = "./phormbase.php3";
    if (!file_exists($ph_phormbase)) $ph_phormbase = "./phormbase.txt";
    if ($ph_debug3) echo "<B>NS:</B> $ph_phormbase<BR>";
    if (!is_readable($ph_phormbase)) {
      $ph_Errs.= "010 - Unable to open file ".$ph_Home."\\$ph_phormbase<BR><BR>\n";
      $ph_Abort = true;
    }
    else {
      $ph_bh = fopen($ph_phormbase, "r");
      while (!feof($ph_bh)) {
        $ph_bline = fgets($ph_bh, 256);
        list($ph_form, $ph_path) = explode($ph_config_delim, trim($ph_bline));
        if ($ph_form == $PHORM_BASE) $ph_chdir = $ph_path;
      }
    }
  }

/*
  Record the configuration variables passed from the form, then unset them */
  if ($ph_ForceDec) {
    while (list($ph_var, $ph_val) = each($GLOBALS))
      if (ereg("^PHORM_", $ph_var)) {
        $ph_varHold[$ph_var] = $ph_val;
        unset($$ph_var);
      }
  }
  reset($GLOBALS);

/*
  Check for the phormconfig.php3 file and process it */
  $ph_phormconfig = "./phormconfig.php3";
  if (!file_exists($ph_phormconfig)) $ph_phormconfig = "./phormconfig.inc";
  if (file_exists($ph_phormconfig)) {
    if ($ph_debug3) echo "<B>NS:</B> $ph_phormconfig<BR>";
    if (!is_readable($ph_phormconfig)) {
      $ph_Errs.= "020 - Unable to open main Phorm configuration file.<BR><BR>\n";
      $ph_Abort = true;
    }
    else {
      include ($ph_phormconfig);
    }
  }

  unset($PHORM_BASE);

  $ph_vLdelims[0] = "\{\{";
  $ph_vLdelims[1] = "{{";
  $ph_vLdelims[2] = "{{2}";
  $ph_vLdelims[3] = "\{{2}";
  $ph_vLdelims[4] = "[{]{2}";
  $ph_vLdelims[5] = "<<";

  $ph_vRdelims[0] = "\}\}";
  $ph_vRdelims[1] = "}}";
  $ph_vRdelims[2] = "}{2}";
  $ph_vRdelims[3] = "\}{2}";
  $ph_vRdelims[4] = "[}]{2}";
  $ph_vRdelims[5] = ">>";

  $ph_vRegs[0] = "\{\{([A-Za-z0-9_]*)\}\}";
  $ph_vRegs[1] = "{{([A-Za-z0-9_]*)}}";
  $ph_vRegs[2] = "{{2}([A-Za-z0-9_]*)}{2}";
  $ph_vRegs[3] = "\{{2}([A-Za-z0-9_]*)\}{2}";
  $ph_vRegs[4] = "[{]{2}([A-Za-z0-9_]*)[}]{2}";
  $ph_vRegs[5] = "<<([A-Za-z0-9_]*)>>";

  if (!$ph_Regex) $ph_Regex = 0;
  if ($ph_Regex > 5) $ph_Regex = 5;

  $ph_rLdelim = ($ph_Regex < 5)? "{{" : "<<";

  $ph_vLdelim = $ph_vLdelims[$ph_Regex];
  $ph_vRdelim = $ph_vRdelims[$ph_Regex];
  $ph_vReg = "$ph_vLdelim([A-Za-z0-9_]*)$ph_vRdelim";
  if ($ph_debug31) echo "\$ph_vReg: ".ereg_replace("<", "&lt;", $ph_vReg)."<BR>\n";

/*
  Restore the value of PHORM_CONFIG */
  $PHORM_CONFIG = $ph_varHold["PHORM_CONFIG"];

/*
  Check $PHORM_RCONFIG */
  if ($PHORM_RCONFIG != "N" && !$PHORM_CONFIG) {
    $ph_Abort = true;
    if ($PHORM_URL) $ph_Redirect = $PHORM_URL;
    else $ph_Errs.=
      "040 - I'm sorry, this page only processes the contents of ".
      "a form. You cannot access it directly.<BR><BR>\n";
  }

/*
  If there was a match in phormbase.txt, change to the specified dir */
  if ($ph_chdir && !$ph_Abort) {
    if ($ph_debug3) echo "<B>NS:</B> chdir($ph_chdir)<BR>";
    if (!@chdir($ph_chdir)) {
      $ph_Errs.= "030 - Invalid directory <B>$ph_chdir</B> in <B>phormbase.txt</B><BR>\n";
      $ph_Abort = true;
    }
  }

/*
  Process the form-specific configuration file, if any */
  if ($PHORM_CONFIG) {
    if ($ph_debug3) echo "<B>NS:</B> PHORM_CONFIG ($PHORM_CONFIG)<BR>";

//  Strip any path info
    $PHORM_CONFIG = basename($PHORM_CONFIG);

//  If it's there and readable, include it; else generate an error.
    if (!is_readable($PHORM_CONFIG)) {
      $ph_Errs.= "050 - Unable to open configuration file <B>$PHORM_CONFIG</B>.<BR><BR>\n";
      $ph_Abort = true;
    }
    else {
      include($PHORM_CONFIG);
    }
  }

/*
  If $PHORM_BASE was set in the config file, change to the specified dir */
  if ($PHORM_BASE && !$ph_Abort) {
    if ($ph_debug3) echo "<B>NS:</B> ".strtoupper($PHORM_CONFIG).":phormbase<BR>";
    chdir($ph_Home);
    if (!@chdir($PHORM_BASE)) {
      $ph_Errs.= "060 - Invalid directory <B>$PHORM_BASE</B> in <B>\$PHORM_CONFIG</B><BR>\n";
      $ph_Abort = true;
    }
  }
  unset($PHORM_BASE);

/*
  Restore only the declared configuration variables from the form */
  if ($ph_ForceDec && is_array($ph_varHold) && !$ph_Abort)
    while (list($ph_var, $ph_val) = each($ph_varHold))
      if ($$ph_var == "{{FORM}}") $$ph_var = $ph_varHold[$ph_var];

/*
  Check for PHPMAIL_ variable names from previous versions */
  if ($PHORM_PHPMAIL && !$ph_Abort) {
    if ($PHPMAIL_ACK && !$PHORM_ACK)
        $PHORM_ACK = $PHPMAIL_ACK;
    if ($PHPMAIL_REQ && !$PHORM_REQ)
        $PHORM_REQ = $PHPMAIL_REQ;
    if ($PHPMAIL_TMPL && !$PHORM_TMPL)
        $PHORM_TMPL = $PHPMAIL_TMPL;
    if ($PHPMAIL_TO && !$PHORM_TO)
        $PHORM_TO = $PHPMAIL_TO;
    if ($PHPMAIL_FROM && !$PHORM_FROM)
        $PHORM_FROM = $PHPMAIL_FROM;
    if ($PHPMAIL_SUBJECT && !$PHORM_SUBJECT)
        $PHORM_SUBJECT = $PHPMAIL_SUBJECT;
    if ($PHPMAIL_LOG && !$PHORM_LOG)
        $PHORM_LOG = $PHPMAIL_LOG;
    if ($PHPMAIL_LOGVAR && !$PHORM_LOGVAR)
        $PHORM_LOGVAR = $PHPMAIL_LOGVAR;
    if ($PHPMAIL_RESP && !$PHORM_RESPOND)
        $PHORM_RESPOND = $PHPMAIL_RESP;
    if ($PHPMAIL_RFROM && !$PHORM_RESFROM)
        $PHORM_RESFROM = $PHPMAIL_RFROM;
    if ($PHPMAIL_RSUBJ && !$PHORM_RESUBJ)
        $PHORM_RESUBJ = $PHPMAIL_RSUBJ;
    if ($PHPMAIL_REPLY && !$PHORM_RESRPLY)
        $PHORM_RESRPLY = $PHPMAIL_REPLY;
  }

  if (is_array($PHORM_TMPL)) list($ph_key, $lPHORM_TMPL) = each($PHORM_TMPL);
  else $lPHORM_TMPL = $PHORM_TMPL;

  if (is_array($PHORM_MYTABLE)) list($ph_key, $lPHORM_MYTABLE) = each($PHORM_MYTABLE);
  else $lPHORM_MYTABLE = $PHORM_MYTABLE;

  if (is_array($PHORM_MYVARS)) list($ph_key, $lPHORM_MYVARS) = each($PHORM_MYVARS);
  else $lPHORM_MYVARS = $PHORM_MYVARS;

  if (!$PHORM_LDELIM) $PHORM_LDELIM = "\t";

  if ($PHORM_MYDBV) {
    if (!is_readable($PHORM_MYDBV))
      $ph_Alerts.= "010 - Unable to open Database variables file $PHORM_MYDBV.\n";
    else
      include($PHORM_MYDBV);
  }

  if ($DHost && $DUser && $DPass && $DBase && !$ph_Abort) {
    if ($ph_debug71) echo "<B>Host:</B> $DHost <B>User:</B> $DUser <B>Pass:</B> $DPass <B>Base:</B> $DBase<BR>";
    $ph_ID = @mysql_connect($DHost, $DUser, $DPass);
    if (!$ph_ID) $ph_Alerts.= "020 - Unable to connect to host $DHost.\n";
    else {
      $ph_selected = @mysql_select_db($DBase, $ph_ID);
      if (!$ph_selected) $ph_Alerts.= "030 - Unable to select database $DBase.\n";
    }
    $ph_dbOpen = ($ph_ID && $ph_selected);
  }

/*
  Perform data validation */
  if ($PHORM_VALDEFS && !$ph_Abort) {
    if ($ph_debug2) echo "<B><B>JS:</B></B> ValDefs ($PHORM_VALDEFS)<BR>";
    if (!$ph_vf = @fopen($PHORM_VALDEFS, "r"))
      $ph_Alerts.= "040 - Unable to open validation file $PHORM_VALDEFS.\n";

    $ph_fidx = 1; $ph_ErrLevel = 0;
    while (!@feof($ph_vf)) {
      $ph_ValErr = false;
      $ph_vlin = trim(fgets($ph_vf, 256));
      if ($ph_debug41) echo "&nbsp;<B>vd:</B>$ph_vlin<BR>";

      switch($ph_vlin) {

      case "":
        break;

      case "FILES" :
        $ph_FILES = true; $ph_RULES = false;
        break;

      case "RULES" :
        $ph_RULES = true; $ph_FILES = false;
        break;

      default:
        if ($ph_FILES) {
          $ph_Files[$ph_fidx++] = $ph_vlin;
          break;
        }

//      If we've made it this far, we're in a RULES section.
//      Parse the line for Criterion, Variable, Level and Comments
        list ($ph_Crit, $ph_Var, $ph_MsgLevel, $ph_Comments) = split($ph_config_delim, $ph_vlin, 4);
        if ($ph_debug411) echo "&nbsp;&nbsp;<B>vd:</B>$ph_Crit>$ph_Var>$ph_MsgLevel>$ph_Comments<BR>";
        $ph_RuleNum++;

//      If there are any arguments, the actual Criterion will be in Args[0].
//      Parse the arguments for variable replacements
        $ph_Args = split(" ", $ph_Crit);
        if ($ph_Args[0]) {
          $ph_Crit = $ph_Args[0];
          for ($ph_idx=1; $ph_idx<sizeof($ph_Args); $ph_idx++) {
            if (ereg("^\{\{[^}]*\}\}$", $ph_Args[$ph_idx])) {
              $ph_Argz = ereg_replace("^\{\{|\}\}$", "", $ph_Args[$ph_idx]);
              $ph_Args[$ph_idx] = $$ph_Argz;
            }
          }
        }

//      Get the value of Variable and check for any concatenated values.
        $ph_Val = $$ph_Var;
        if ($ph_ValCat) {
          $ph_Val = $ph_ValCat.$ph_Val;
          $ph_ValCat = "";
        }
        if ($ph_debug411) echo "&nbsp;&nbsp;<B>vd:</B>$ph_Crit [$ph_Var:$ph_Val]<BR>";

        if ($ph_Crit != "+") {
//        Load the message
          $ph_Msg = "";
          $ph_mlin = fgets($ph_vf, 256);
          if ($ph_debug41) echo "&nbsp;<B>vd:</B>".ereg_replace("<", "&lt;", $ph_mlin)."<BR>";
          while(!ereg("^###", $ph_mlin)) {
            $ph_Msg .= $ph_mlin;
            $ph_mlin = fgets($ph_vf, 256);
            if ($ph_debug41) echo "&nbsp;<B>vd:</B>$ph_mlin<BR>";
          }
        }

        switch ($ph_Crit) {

        case "REQ" :
          if ($ph_Val == "") $ph_ValErr = true;
          break;

        case "REGEX" :
          if (!isset($ph_Args[1]))
            $ph_Alerts.= "041 - REGEX criterion requires one argument.\n";
          if (!ereg($ph_Args[1], $ph_Val)) $ph_ValErr = true;
          break;

        case "UNIQUE" :
          if (!isset($ph_Args[2]))
            $ph_Alerts.= "051 - UNIQUE criterion requires two arguments.\n";
          if (!$ph_dbOpen)
            $ph_Alerts.= "052 - UNIQUE criterion requires a database to be open.\n";
          else {
            $ph_uCol = $ph_Args[1];
            if (is_array($PHORM_MYTABLE))            
              $ph_uTable = $PHORM_MYTABLE[$ph_Args[2]];
            else $ph_uTable = $PHORM_MYTABLE;
            $ph_QString = "select * from $ph_uTable where $ph_uCol='$ph_Val'";
            $ph_Result = MySQL_Query($ph_QString, $ph_ID);
            if (!$ph_Result || MySQL_Error()) 
              $ph_Alerts.= "053 - Error on query:\n   $ph_QString\n <B>MySQL says</B>: ".ereg_replace("[^A-z0-9'., ]","",MySQL_Error())."\n";
            else 
              if (MySQL_Num_Rows($ph_Result) > 0) $ph_ValErr = true;
          }
          break;

        case "EMAIL" :
          $ph_EmLevel = $ph_Args[1];
          if (!$ph_EmLevel) $ph_EmLevel = 1;
          if (trim($ph_Val) && MailChek($ph_Val, $ph_EmLevel)) $ph_ValErr = true;
          break;

        case "CCARD" :
          if (!$ph_Args[1])
            $ph_Alerts.= "042 - CCARD criterion requires one argument.\n";
          $ph_Valh = $ph_Val;

//        Strip any non-digits out of the card number
          $ph_CType = $$ph_Args[1]; $ph_CType = strtolower($ph_CType);
          if (strlen($ph_CType) > 3) $ph_CType = $ph_Cards[$ph_CType];
          $ph_Val = ereg_replace("[^[:digit:]]", "", $ph_Val);
          if (strlen($ph_Val) < 12) $ph_CType = "";

          $ph_CVal = false;
          switch ($ph_CType) {

          case "mcd" :
            $ph_CVal = (ereg("^5[1-5].{14}$", $ph_Val) && ph_luhn($ph_Val));
            break;

          case "vis" :
            $ph_CVal = (ereg("^4.{15}$|^4.{12}$", $ph_Val) &&
                        ph_luhn($ph_Val));
            break;

          case "amx" :
            $ph_CVal = (ereg("^3[47].{13}$", $ph_Val) &&
                        ph_luhn($ph_Val));
            break;

          case "dsc" :
            $ph_CVal = (ereg("^6011.{12}$", $ph_Val) &&
                        ph_luhn($ph_Val));
            break;

          case "dnc" :
            $ph_CVal = (ereg("^30[0-5].{11}$|^3[68].{12}$", $ph_Val) &&
                        ph_luhn($ph_Val));
            break;

          case "jcb" :
            $ph_CVal = (ereg("^3.{15}$|^2131|1800.{11}$", $ph_Val) &&
                        ph_luhn($ph_Val));
            break;
          } // switch ($ph_CType)

          if ($ph_Valh && !$ph_CVal) $ph_ValErr = true;
          break;

        case "PHONE" :
          $ph_Match = ereg("^(\(?[0-9]{3}\)?[ -])?[0-9]{3}[ -][0-9]{4}$", $ph_Val);
          if ($ph_Val && !$ph_Match) $ph_ValErr = true;
          break;

        case "PHONEC" :
          if (!ereg("^[0-9() +-]*$", $ph_Val)) $ph_ValErr = true;
          break;

        case "RANGE" :
          if (!isset($ph_Args[2]))
            $ph_Alerts.= "043 - RANGE criterion requires two arguments.\n";
          if (isset($ph_Val) && ($ph_Val < $ph_Args[1] || $ph_Val > $ph_Args[2]))
            $ph_ValErr = true;
          break;

        case "ONEOF" :
          if (!isset($ph_Args[1]))
            $ph_Alerts.= "044 - ONEOF criterion requires at least one argument.\n";
          $ph_aidx = 1; $ph_Match = false;
          while ($ph_Args[$ph_aidx])
             if ($ph_Args[$ph_aidx++] == $ph_Val) $ph_Match = true;
          if (isset($ph_Val) && !$ph_Match) $ph_ValErr = true;
          break;

        case "ALPHA" :
          if (!ereg("^[A-Za-z]$", $ph_Val)) $ph_ValErr = true;
          break;

        case "NUMERIC" :
          if (!ereg("^[-+0-9]?[.,0-9]*[0-9.]$", $ph_Val)) $ph_ValErr = true;
          break;

        case "GT" :
          if (!isset($ph_Args[1])) $ph_Alerts.= "045 - GT criterion requires an argument.\n";
          if (isset($ph_Val) && $ph_Val <= $ph_Args[1]) $ph_ValErr = true;
          break;

        case "LT" :
          if (!isset($ph_Args[1])) $ph_Alerts.= "046 - LT criterion requires an argument.\n";
          if (isset($ph_Val) && $ph_Val >= $ph_Args[1]) $ph_ValErr = true;
          break;

        case "EQ" :
          if (!isset($ph_Args[1])) $ph_Alerts.= "047 - EQ criterion requires an argument.\n";
          if (isset($ph_Val) && $ph_Val != $ph_Args[1]) $ph_ValErr = true;
          break;

        case "GE" :
          if (!isset($ph_Args[1])) $ph_Alerts.= "048 - GE criterion requires an argument.\n";
          if (isset($ph_Val) && $ph_Val < $ph_Args[1]) $ph_ValErr = true;
          break;

        case "LE" :
          if (!isset($ph_Args[1])) $ph_Alerts.= "049 - LE criterion requires an argument.\n";
          if (isset($ph_Val) && $ph_Val > $ph_Args[1]) $ph_ValErr = true;
          break;

        case "NE" :
          if (!isset($ph_Args[1])) $ph_Alerts.= "050 - NE criterion requires an argument.\n";
          if (isset($ph_Val) && $ph_Val = $ph_Args[1]) $ph_ValErr = true;
          break;

        case "+" :
          $ph_ValCat .= $ph_Val;
          break;

        default:
          if ($ph_RULES) $ph_Alerts.= "058 - Invalid criterion: $ph_Crit\n";

        } // switch ($ph_Crit)
        if ($ph_ValErr) {
          if ($ph_Invals) $ph_Invals.= ",";
          $ph_Invals.= $ph_RuleNum;
          $ph_ErrLevel = max($ph_ErrLevel, $ph_MsgLevel);
          if ($ph_ValMsg[$ph_MsgLevel])
            $ph_ValMsg[$ph_MsgLevel] .= "\n<BR><BR>\n\n";
          $ph_ValMsg[$ph_MsgLevel] .= $ph_Msg;
        }
      } // switch($ph_vlin)
    } // while (!feof)

    if ($ph_ErrLevel) {
      $ph_errfile = $ph_ErrLevel;
      $ph_MaxFile = sizeof($ph_Files);
      if ($ph_errfile > $ph_MaxFile) $ph_errfile = $ph_MaxFile;

//    If we can't open the error file, make our own.
      if (!is_readable($ph_Files[$ph_errfile])) {
        $ph_Alerts.=
          "059 - Unable to open validation error file $ph_Files[$ph_errfile].\n";

//      Parse the line for variable replacements.
        $ph_eline = $ph_ValMsg[$ph_ErrLevel];
        while (ereg($ph_vReg, $ph_eline, $ph_regs)) {
          $$ph_regs[1] = ereg_replace($ph_vLdelim, ";:;:;:", $$ph_regs[1]);
          $ph_eline = ereg_replace($ph_regs[0], $$ph_regs[1], $ph_eline);
        }
        $ph_eline = ereg_replace(";:;:;:", $ph_rLdelim, $ph_eline);
        $ph_ValMsg[$ph_ErrLevel] = $ph_eline;

        echo "<HMTL>\n".
             "<HEAD>\n".
             "<TITLE>Phorm Validation Error</TITLE>\n".
             "</HEAD>\n".
             "<BODY BGCOLOR=#FFC0C0 TEXT=#800000>\n".
             "<BR>\n\n".
             "$ph_ValMsg[$ph_ErrLevel]\n\n".
             "$ph_HTLink\n".
             "</BODY>\n".
             "</HTML>";
      }
//    Otherwise, read and parse the error file
      else {
        $ph_ErrFile = file($ph_Files[$ph_errfile]);
        $ph_ErrFile = implode("", $ph_ErrFile);

//      Add our tag at the end of the file.
        if (eregi("</BODY>", $ph_ErrFile))
          $ph_ErrFile = eregi_replace("</BODY>", "$ph_HTLink\n<!-- Generated by Phorm -->\n</BODY>", $ph_ErrFile);
        else
          $ph_ErrFile.= "$ph_HTLink<!-- Generated by Phorm -->";

//      Insert the error message(s) in the appropriate place
        $ph_ErrFile = eregi_replace("<!-- Phorm Messages -->", $ph_ValMsg[$ph_ErrLevel], $ph_ErrFile);

//      Parse the file for variable replacements.
        while (ereg($ph_vReg, $ph_ErrFile, $ph_regs)) {
          $$ph_regs[1] = ereg_replace($ph_vLdelim, ";:;:;:", $$ph_regs[1]);
          $ph_ErrFile = ereg_replace($ph_regs[0], $$ph_regs[1], $ph_ErrFile);
        }
        $ph_eline = ereg_replace(";:;:;:", $ph_rLdelim, $ph_ErrFile);

//      Parse the file for form fields for data recycling
        $ph_ErrBlock = $ph_ErrFile;
        while (eregi("<INPUT[^>]*>|<TEXTAREA[^>]*>|<SELECT[^>]*>",
               $ph_ErrBlock, $ph_regs)) {
          $ph_Tag = $ph_regs[0];
          $ph_TagLen = strlen($ph_Tag);
          $ph_RegTag = $ph_Tag;
          $ph_ErrBlock = substr($ph_ErrBlock, strpos($ph_ErrBlock, $ph_Tag) + $ph_TagLen);

          $ph_Atts = ParseTag($ph_Tag);
          $ph_TAG   = $ph_Atts["TAG"];
          $ph_TYPE  = $ph_Atts["TYPE"];
          $ph_VALUE = $ph_Atts["VALUE"];
          $ph_NAME  = ereg_replace("\[\]", "", $ph_Atts["NAME"]);

          switch($ph_TAG) {

          case "INPUT":
            if ($$ph_NAME) {
              switch(strtoupper($ph_TYPE)) {

              case ""      :
              case "TEXT"  :
                if ($ph_Atts["VALUE"])
                  $ph_RepTag = ereg_replace(QuoteMeta($ph_Atts["VALUE"]), $$ph_Atts["NAME"], $ph_RegTag);
                else
                  $ph_RepTag = ereg_replace(">", " VALUE=\"".$$ph_Atts["NAME"]."\">", $ph_RegTag);
                $ph_ErrFile = ereg_replace(QuoteMeta($ph_RegTag), $ph_RepTag, $ph_ErrFile);
                break;

              case "CHECKBOX" :
                if (!is_array($$ph_NAME) ||
                   ( is_array($$ph_NAME) && inarray($ph_VALUE, $$ph_NAME))) {
                  $ph_RepTag = ereg_replace(">", " CHECKED>", $ph_RegTag);
                  $ph_ErrFile = ereg_replace(QuoteMeta($ph_RegTag), $ph_RepTag, $ph_ErrFile);
                }
                break;

              case "RADIO" :
                if ($$ph_Atts["NAME"] == $ph_Atts["VALUE"]) {
                  $ph_RepTag = ereg_replace(">", " CHECKED>", $ph_RegTag);
                  $ph_ErrFile = ereg_replace(QuoteMeta($ph_RegTag), $ph_RepTag, $ph_ErrFile);
                }
                break;

              } // Switch
            } // if ($$ph_NAME)
            break;

          case "TEXTAREA":
            if ($$ph_NAME) {
              $ph_TClose = strpos(strtoupper($ph_ErrBlock), "</TEXTAREA");
              if (is_integer($ph_TClose)) {
                $ph_TVal = substr($ph_ErrBlock, 0, $ph_TClose);
                $ph_ErrFile = ereg_replace (
                           QuoteMeta($ph_Tag).QuoteMeta($ph_TVal)."</TEXTAREA",
                           $ph_Tag.$$ph_NAME."</TEXTAREA",
                           $ph_ErrFile);
              }
            }
            break;

          case "SELECT":
            $ph_EndSel = strpos(strtoupper($ph_ErrBlock), "</SELECT");
            $ph_SelBlock = substr($ph_ErrBlock, 0, $ph_EndSel + 9);
            $ph_ErrBlock = substr($ph_ErrBlock, strlen($ph_SelBlock));

            $ph_RegBlock = QuoteMeta($ph_SelBlock);
            $ph_RepBlock = $ph_SelBlock;

            if ($$ph_NAME) {
              if (is_array($$ph_NAME))
                $ph_Selected = implode("\n", $$ph_NAME)."\n";
              else
                $ph_Selected = $$ph_NAME."\n";

              while (eregi("<OPTION[^>]*>", $ph_SelBlock, $ph_regs)) {
                $ph_oTag = $ph_regs[0];
                $ph_oTagLen = strlen($ph_oTag);
                $ph_RegTag = QuoteMeta($ph_oTag);

                $ph_SelBlock = substr($ph_SelBlock, strpos($ph_SelBlock, $ph_oTag) + $ph_oTagLen);
                $ph_oAtts = ParseTag($ph_oTag);
                $ph_VALUE = $ph_oAtts["VALUE"];

                $ph_oTag = eregi_replace("SELECTED", "", $ph_oTag);
                if (ereg($ph_VALUE."\n", $ph_Selected)) {
                  $ph_oTag = ereg_replace(">", " SELECTED>", $ph_oTag);
                }
                $ph_RepBlock = ereg_replace($ph_RegTag, $ph_oTag, $ph_RepBlock);

              } // while <OPTION>

               $ph_ErrFile = ereg_replace($ph_RegBlock, $ph_RepBlock, $ph_ErrFile);
            } // if ($$ph_NAME)

          } // switch ($ph_TAG)
        } // while <INPUT|TEXTAREA|SELECT>

        echo $ph_ErrFile;
      } // else (parse error file)

      $ph_Abort = true;

    } // if ($ph_ErrLevel)
  } // if ($PHORM_VALDEFS)

/* If there's no ack template, set the re-direct to $PHORM_RDIRECT. If that is not set, 
   attempt to redirect back to the calling form. Note that if $HTTP_REFERER is empty in
   this case, the visitor will get a "302 Found" result (from Apache, anyway) */
  if (!$PHORM_ACK) {
    if (!$HTTP_REFERER && !$PHORM_RDIRECT) $ph_Alerts.= 
      "060 - No ack template or re-direct specified, and \$HTTP_REFERER ".
      "is empty. Visitor received \"302 Found\" status message.\n";
    if (!$ph_Redirect) $ph_Redirect = $PHORM_RDIRECT;
    if (!$ph_Redirect) $ph_Redirect = $HTTP_REFERER;
  }

/*
  Open the acknowledgement template file. */
  if ($PHORM_ACK && !$ph_Abort)  {
    if ($ph_debug3) echo "NS: Open Ack Template <B>$PHORM_ACK</B>.<BR>";
    if (!$ph_af = @fopen($PHORM_ACK,"r")) {
      $ph_Errs.= "070 - Unable to open acknowledgement template file ".
                 "<B>$PHORM_ACK</B>.<BR><BR>\n";
      $ph_Abort = true;
    }
  }

/*
  Open the autoresponder template file */
  if ($PHORM_RESPOND && !$ph_Abort) {
    if ($ph_debug3) echo "NS: Open Responder <B>$PHORM_RESPOND</B>.<BR>";
    if (!$ph_rf = @fopen($PHORM_RESPOND, "r"))
      $ph_Alerts.= "070 - Unable to open autoresponder template file $PHORM_RESPOND.\n";
  }

/*
  Open the log file */
  if ($PHORM_LOG && $PHORM_LOGVAR && !$ph_Abort) {
    if ($ph_debug3) echo "NS: Open Log File <B>$PHORM_LOG</B>.<BR>";
    if (!$ph_lf = @fopen($PHORM_LOG, "a"))
      $ph_Alerts.= "080 - Unable to open the log file $PHORM_LOG.\n";
  }

/*
  Check required fields */
  if ($PHORM_REQ && !$PHORM_VALDEFS && !$ph_Abort) {
    if ($ph_debug3) echo "NS: PHORM_REQ";
    $ph_ReqHdr =
     "<HMTL><HEAD><TITLE>Phorm Required Field Missing</TITLE>".
     "<BODY BGCOLOR=#FFC0C0 TEXT=#800000><FONT SIZE=5>".
     "The following required fields are empty:</FONT><FONT SIZE=4><BR><BR>";
    $ph_ReqVars = explode(" ", $PHORM_REQ);
    $ph_idx = 0;
    while ($ph_ReqVars[$ph_idx]) {
      if (!$$ph_ReqVars[$ph_idx]) {
        echo $ph_ReqHdr, $ph_ReqVars[$ph_idx], "<BR>";
        $ph_ReqHdr = "";
      }
      $ph_idx++;
    }
    if (!$ph_ReqHdr) {
      echo $ph_HTLink; echo "</FONT></BODY></HMTL>";
      exit;
    }
  }

/*
  Read the autoresponder template and email it back to the visitor */
  if ($ph_rf && $PHORM_FROM && !$ph_Abort) {
    if ($ph_debug2) echo "<B>JS:</B> Parse Autoresponder <B>$PHORM_RESPOND</B>.<BR>";
    $ph_Message = "";

    while(!feof($ph_rf)) {
      $ph_rline = fgets($ph_rf, 1024);

//    Parse the line for variable replacements.
      while (ereg($ph_vReg, $ph_rline, $ph_regs)) {
        $$ph_regs[1] = ereg_replace($ph_vLdelim, ";:;:;:", $$ph_regs[1]);
        $ph_rline = ereg_replace($ph_regs[0], $$ph_regs[1], $ph_rline);
      }
      $ph_rline = ereg_replace(";:;:;:", $ph_rLdelim, $ph_rline);

      $ph_Message.= $ph_rline;
    } // (!feof($ph_rf))

//  Add our tag at the end of the message.
    if ($ph_HTTag) $ph_Message.= $ph_HTTag;

//  Construct the headers and send the message
    $ph_Headers = "From: $PHORM_RESFROM\n";
    if (PHORM_RESRPLY)
      $ph_Headers.= "Reply-to: $PHORM_RESRPLY\n";
    $PHORM_RESHDRS = eregi_replace("X-Mailer:[^"."\n"."]*\n", "", $PHORM_RESHDRS);
    $ph_Headers.= $PHORM_RESHDRS."X-Mailer: PHP/$ph_Vers\n";

    Mail($PHORM_FROM,
         $PHORM_RESUBJ,
         $ph_Message,
         $ph_Headers);

    fclose($ph_rf);
  } // ($PHORM_RESPOND)

/*
  Log variables to the text log file. */
  if ($ph_lf && !$ph_Abort) {
    if ($ph_debug2) echo "<B>JS:</B> Log to text file <B>$PHORM_LOG</B>.<BR>";
    $ph_LogVars = explode(" ", $PHORM_LOGVAR);
    $ph_idx = 0;
    $ph_LogLine = "";
    while ($ph_LogVars[$ph_idx]) {
      if (ereg("'", $ph_LogVars[$ph_idx])) $ph_Quote = $PHORM_LOGQUOT; else $ph_Quote = "";
      $ph_LogVars[$ph_idx] = ereg_replace("'", "", $ph_LogVars[$ph_idx]);
      $ph_LogLine = $ph_LogLine.$ph_Quote.$$ph_LogVars[$ph_idx].$ph_Quote.$PHORM_LDELIM;
      $ph_idx++;
    }
    fputs($ph_lf, $ph_LogLine."\n");
    fclose($ph_lf);
  }

/*
  Log to MySQL Database */
  if ($ph_dbOpen && $lPHORM_MYTABLE && $lPHORM_MYVARS && !$ph_Abort) {
    if ($ph_debug2) echo "<B>JS:</B> MySQL Logger.<BR>";

    while ($lPHORM_MYTABLE && $lPHORM_MYVARS) {
      $ph_CVPairs = split(",", $lPHORM_MYVARS);
      $ph_idx = -1;
      $ph_Vals = "'";
      $ph_Cols = "";
      while ($ph_CVPairs[++$ph_idx]) {
        list($ph_Col, $ph_Val) = split("=", $ph_CVPairs[$ph_idx]);
        if ($ph_Cols) $ph_Cols.= ",";
        if (strlen($ph_Vals) > 1) $ph_Vals.= ",'";
        $ph_Value = $$ph_Val;

        if (phpversion() >= "3.0.6") {
          if (!get_magic_quotes_gpc()) $ph_Value = AddSlashes($ph_Value);
        }
        else
          if ($PHORM_QUOTES) $ph_Value = AddSlashes($ph_Value);

        $ph_Vals.= $ph_Value."'";
        $ph_Cols.= $ph_Col;
      }
      $ph_QString = "insert into $lPHORM_MYTABLE ($ph_Cols) values ($ph_Vals)";
      if ($ph_debug72) echo "<B>Q:</B> $ph_QString<BR>";
      $ph_Result = MySQL_Query($ph_QString, $ph_ID);
      if (!$ph_Result) $ph_Alerts.= "090 - Error on query:\n   $ph_QString\n <B>MySQL says</B>: ".ereg_replace("[^A-z0-9'., ]","",MySQL_Error())."\n";
      if (is_array($PHORM_MYTABLE) && is_array($PHORM_MYVARS)) {
        list($ph_nul, $lPHORM_MYTABLE) = each($PHORM_MYTABLE);
        list($ph_nul, $lPHORM_MYVARS) = each($PHORM_MYVARS);
      }
      else {
         $lPHORM_MYTABLE = "";
         $lPHORM_MYVARS = "";
      }
    }
  }

/*
  Read the mail template file(s) and mail it (them) to the user */
  if ($lPHORM_TMPL && !$ph_Abort) {
    if ($ph_debug2) echo "<B>JS:</B> Mail Template(s)<BR>";
    $mPHORM_TMPL = false; $ph_tmax = 25;
    if (sizeof($PHORM_TMPL) > $ph_tmax)
      $ph_Alerts.= "100 - You may not have more than $ph_tmax email templates in \$PHORM_TMPL.\n";
    do {
      if ($ph_debug8) echo "Mail Template <B>$lPHORM_TMPL</B><BR>";
      if (!$ph_tf = @fopen($lPHORM_TMPL, "r"))
        $ph_Alerts.= "101 - Unable to open mail template file $lPHORM_TMPL.\n";
      else {
        $ph_Message = "";
        $ph_Headers = "";
        $ph_tHeaders = true;
        if (!$PHORM_FROM) { $PHORM_FROM = $PHORM_TO; }
        if (!$mPHORM_TMPL) {
          $ph_tHeaders = false;
          $lPHORM_TO = $PHORM_TO;
          $lPHORM_SUBJECT = $PHORM_SUBJECT;
          $ph_Headers = "From: $PHORM_FROM\n";
        }
        while(!feof($ph_tf)) {
          $ph_tline = fgets($ph_tf, 1024);
          if ($ph_debug81) echo nl2br($ph_tline);

//        Parse the line for variable replacements.
          while (ereg($ph_vReg, $ph_tline, $ph_regs)) { 
            $$ph_regs[1] = ereg_replace($ph_vLdelim, ";:;:;:", $$ph_regs[1]);
//          $ph_regs[0] = ereg_replace("\{", "\\{", $ph_regs[0]);
//          $ph_regs[0] = ereg_replace("\}", "\\}", $ph_regs[0]);
            $ph_tline = ereg_replace($ph_regs[0], $$ph_regs[1], $ph_tline);
          }
          $ph_tline = ereg_replace(";:;:;:", $ph_rLdelim, $ph_tline);
          if ($ph_debug812) echo nl2br($ph_tline);

          if (!trim($ph_tline)) $ph_tHeaders = false;
          if ($ph_tHeaders) {
            $ph_tline = ereg_replace("\r|\n", "", $ph_tline);
            if (eregi("^X-", $ph_tline)) $ph_Headers.= $ph_tline."\n";
            if (eregi("^To: ", $ph_tline))
              $lPHORM_TO = eregi_replace("^To: ", "", $ph_tline);

            elseif (eregi("^Subject: ", $ph_tline))
              $lPHORM_SUBJECT = eregi_replace("^Subject: ", "", $ph_tline);

            elseif (eregi("^From: ", $ph_tline))
              $ph_Headers.= $ph_tline."\n";

            else
              $ph_Alerts.= "102 - Invalid email header '$ph_tline' in $lPHORM_TMPL.\n";
          }
          else $ph_Message.= $ph_tline;
        } // (!feof($ph_tf))

        $PHORM_HEADERS = eregi_replace("X-Mailer:[^"."\n"."]*\n", "", $PHORM_HEADERS);
        $ph_Headers.= $PHORM_HEADERS."X-Mailer: PHP/$ph_Vers";
        if ($ph_debug82) 
          echo
          "\$PHORM_TO: $lPHORM_TO<BR>".
          "\$PHORM_SUBJECT: $lPHORM_SUBJECT<BR>\n".
          "\$ph_Headers:<BR>$ph_Headers<BR><BR>\n".
          "\$ph_Message:<BR>$ph_Message<BR>\n";
        Mail($lPHORM_TO,
             $lPHORM_SUBJECT,
             $ph_Message,
             $ph_Headers);

        fclose($ph_tf);
      } // if (!$ph_tf)/else

//    If PHORM_TMPL is an array, get the next element.
      if (is_array($PHORM_TMPL))
        $mPHORM_TMPL = (list($ph_key, $lPHORM_TMPL) = each($PHORM_TMPL));
    } while ($mPHORM_TMPL && --$ph_tmax);
  } // if ($lPHORM_TMPL)

/*
  Read the ack template and output it. Temporarily changing {{ and }} in the visitor's input
  to :{:{ and :}:} prevents them from displaying internal variables. */
  if ($ph_af && !$ph_Abort)  {
    if ($ph_debug2) echo "<B>JS:</B> Ack Template <B>$PHORM_ACK</B><BR>";
    while(!feof($ph_af)) {
      $ph_aline = fgets($ph_af, 1024);
      $ph_aline = eregi_replace("<!-- Phorm Messages -->", $ph_ValMsg[0], $ph_aline);

//    Add our tag at the end of the file.
      if ((ereg("</BODY>", $ph_aline) || feof($ph_af)) && !$PHORM_tagd) {
        echo $ph_HTLink; echo "<!-- Generated by Phorm -->"; $PHORM_tagd=true; }

//    Parse the line for variable replacements.
      while (ereg($ph_vReg, $ph_aline, $ph_regs)) {
        $$ph_regs[1] = ereg_replace($ph_vLdelim, ";:;:;:", $$ph_regs[1]);
        $ph_aline = ereg_replace($ph_regs[0], $$ph_regs[1], $ph_aline);
      }
      $ph_aline = ereg_replace(";:;:;:", $ph_rLdelim, $ph_aline);

      echo $ph_aline;
    } // (!feof($ph_af))
    fclose($ph_af);
  } // (PHORM_ACK)

/*
  If PHORM_POSTINC is defined, include it. */
  if ($PHORM_POSTINC)  {
    if ($ph_debug3) echo "NS: Post Processing <B>$PHORM_POSTINC</B>.<BR>";
    if (!is_readable($PHORM_POSTINC)) {
      $ph_Alerts.= "110 - Unable to execute post-processing file ".
                 "<B>$PHORM_POSTINC</B>.<BR><BR>\n";
      $ph_Abort = true;
    }
    else include($PHORM_POSTINC);
  }

/*
  Display any fatal error messages to the visitor, along with internal
  alerts, if PHORM_ALERTTO is not defined. */
  if ($ph_Errs || ($ph_Alerts && ($ph_debug1 || !$PHORM_ALERTTO))) {
    unset($ph_Redirect);
    echo "<HMTL>\n".
         "<HEAD>\n".
         "<TITLE>Phorm Error</TITLE>\n".
         "</HEAD>\n".
         "<BODY BGCOLOR=#FFC0C0 TEXT=#800000>\n".
         "\n";
    if ($ph_Errs) echo "<FONT SIZE=5>ERROR<BR><BR></FONT>\n".
                       "$ph_Errs\n";
    if ($ph_Alerts && ($ph_debug1 || !$PHORM_ALERTTO)) {
      $ph_Alerts = nl2br($ph_Alerts);
      echo "Alerts:<BR> $ph_Alerts";
    }
    echo "$ph_HTLink\n".
         "</BODY></HTML>";
  }

/*
  Email any alerts and errors to the user, if an address was specified. */
  if (($ph_Alerts || $ph_Errs) && $PHORM_ALERTTO) {
    $ph_Errs   = ereg_replace("<[^>]*>", "", $ph_Errs);
    $ph_Alerts = ereg_replace("<[^>]*>", "", $ph_Alerts);
    $ph_Message = "Internal Alerts:\n$ph_Alerts\n";
    if ($ph_Errs)
      $ph_Message.= "Fatal errors displayed to visitor:\n$ph_Errs\n";
    $ph_Message.= "Phorm Variables:\n";
    while (list($ph_key, $ph_val) = each($GLOBALS)) {
      if (ereg("^PHORM_", $ph_key)) {
        $ph_Message.= "$ph_key: $ph_val\n";
      }
    }
    reset($GLOBALS);
    $ph_Message.= "\nHTTP_REFERER: $HTTP_REFERER\nREMOTE_ADDR: $REMOTE_ADDR\n";
    $ph_Message.= $ph_HTTag;
    if (!$PHORM_ALERTFRM) $PHORM_ALERTFRM = "Phorm Processor <Phorm.Processor>";
    $ph_Headers = "From: $PHORM_ALERTFRM\n".
                  "X-Mailer: PHP3/$ph_Vers\n";
    Mail($PHORM_ALERTTO,
         "Phorm Alert",
         $ph_Message,
         $ph_Headers);
  }
  if ($ph_Redirect) Header("Location: $ph_Redirect");
?>